searchData={"items":[{"type":"module","title":"ExSCTP","doc":"Utilities for establishing SCTP connection and sending data over it.","ref":"ExSCTP.html"},{"type":"function","title":"ExSCTP.close_stream/2","doc":"Closes the stream with `id`.\n\nCalling this function will result in new events. See `poll/1` for more information.","ref":"ExSCTP.html#close_stream/2"},{"type":"function","title":"ExSCTP.configure_stream/5","doc":"Sets stream's order and reliability parameters.","ref":"ExSCTP.html#configure_stream/5"},{"type":"function","title":"ExSCTP.connect/1","doc":"Triggers connection establishment.\n\nCalling this function will result in new events. See `poll/1` for more information.\nCalling this function after `:connected` event was received will result in an error.","ref":"ExSCTP.html#connect/1"},{"type":"function","title":"ExSCTP.handle_data/2","doc":"Handles data received from other peer.\n\nCalling this function will result in new events. See `poll/1` for more information.","ref":"ExSCTP.html#handle_data/2"},{"type":"function","title":"ExSCTP.handle_timeout/1","doc":"Handles timeout.\n\nAfter receiving `{:timeout, ms}` event from `poll/1`, you must call this function after `ms` milliseconds.\nCalling this function will result in new events. See `poll/1` for more information.","ref":"ExSCTP.html#handle_timeout/1"},{"type":"function","title":"ExSCTP.new/0","doc":"Initializes new SCTP connection state.","ref":"ExSCTP.html#new/0"},{"type":"function","title":"ExSCTP.open_stream/2","doc":"Opens a new stream with specified `id`.\n\nCalling this function will result in new events. See `poll/1` for more information.\nStream IDs need to be unique. Calling this function with already existing stream `id`\nwill rsult in an error.","ref":"ExSCTP.html#open_stream/2"},{"type":"function","title":"ExSCTP.poll/1","doc":"Produces event that needs to be handled by the library user.\n\nNew events can happen after IO is performed or timeout occurs. Related functions in\nthis module specify explicitly that they result in new events. If such a function is called,\nthe user needs to call `poll/1` repeatedly and handle the events until the `:none` event is received.\n\nSee `t:event/0` to learn how to handle events.","ref":"ExSCTP.html#poll/1"},{"type":"function","title":"ExSCTP.send/4","doc":"Sends data over specified stream using provided `ppi`.\n\nCalling this function will result in new events. See `poll/1` for more information.","ref":"ExSCTP.html#send/4"},{"type":"type","title":"ExSCTP.event/0","doc":"Event obtained by calling `poll/1`.\n\nMeaning of the events:\n* `:none` - there's no more events to handle and no actions need to be taken\n* `:connected` and `:disconnected` - STCP connection has been established or closed\n* `{:stream_opened, id}` and `{:stream_closed, id}` - remote side either opened or closed a\nstream with provided `id`. This message is not created for locally opened or closed streams\n(by calling `open_stream/2` or `close_stream/2`)\n* `{:data, id, ppi, data}` - data was received on stream with `id` and is marked with `ppi` PPI\n* `{:transmit, [data]}` - data needs to be transmited to the other peer. You need to send the packets\nusing appropriate means, e.g. DTLS over ICE in case of WebRTC\n* `{:timeout, val}` - informs that `handle_timeout/1` needs to be called after `val` milliseconds.\nIf `val` is `nil`, `handle_timeout/1` won't need to be called and awaiting timeouts can be canceled","ref":"ExSCTP.html#t:event/0"},{"type":"type","title":"ExSCTP.ppi/0","doc":"SCTP Payload Protocol Identifier.","ref":"ExSCTP.html#t:ppi/0"},{"type":"type","title":"ExSCTP.reliability_type/0","doc":"SCTP stream reliability types.","ref":"ExSCTP.html#t:reliability_type/0"},{"type":"type","title":"ExSCTP.stream_id/0","doc":"ID of the SCTP stream.","ref":"ExSCTP.html#t:stream_id/0"},{"type":"opaque","title":"ExSCTP.t/0","doc":"Reference to mutable SCTP state.\n\nOperate on it only using functions from this module.","ref":"ExSCTP.html#t:t/0"},{"type":"extras","title":"ExSCTP","doc":"# ExSCTP\n[![Hex.pm](https://img.shields.io/hexpm/v/ex_sctp.svg)](https://hex.pm/packages/ex_sctp)\n[![API Docs](https://img.shields.io/badge/api-docs-yellow.svg?style=flat)](https://hexdocs.pm/ex_sctp)\n[![CI](https://img.shields.io/github/actions/workflow/status/elixir-webrtc/ex_sctp/ci.yml?logo=github&label=CI)](https://github.com/elixir-webrtc/ex_scttp/actions/workflows/ci.yml)\n[![codecov](https://codecov.io/gh/elixir-webrtc/ex_sctp/graph/badge.svg?token=E98NHC8B00)](https://codecov.io/gh/elixir-webrtc/ex_sctp)\n\nElixir wrapper for [`sctp_proto`](https://docs.rs/sctp-proto/latest/sctp_proto/) library.","ref":"readme.html"},{"type":"extras","title":"Installation - ExSCTP","doc":"Add `ex_sctp` to dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:ex_sctp, \"~> 0.1.0\"}\n  ]\nend\n```\n\nPlease note that `ex_sctp` requires you to have Rust installed in order to compile.","ref":"readme.html#installation"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}